/*
  tpm.h
  Copyright (c) J.J. Green 2019
*/

#ifndef TPM_H
#define TPM_H

#include "colour.h"

#include <stddef.h>

#define TPM_STOPS_MAX 50

typedef struct tpm_t tpm_t;

typedef struct
{
  double fraction;
  rgb_t lead, trail;
} tpm_point_t;

extern tpm_t* tpm_new(void);
extern void tpm_destroy(tpm_t*);

extern int tpm_push(tpm_t*, tpm_point_t*);
extern int tpm_each_point(tpm_t*, int (*)(void*, void*), void*);
extern int tpm_manicure(tpm_t*);
extern size_t tpm_npoint(tpm_t*);

#endif
